## digikam 8.7.0

=== CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2025, Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

set(CMAKE_MIN_VERSION   "3.16")

cmake_minimum_required(VERSION ${CMAKE_MIN_VERSION})

message(STATUS "CMake version: ${CMAKE_VERSION}")

# ==============================================================================
# Information to update before to release this package.

# digiKam version
set(DIGIKAM_MAJOR_VERSION "8")
set(DIGIKAM_MINOR_VERSION "7")
set(DIGIKAM_PATCH_VERSION "0")

# Suffix to add at end of version string. Usual values are:
# "-git"   : alpha code unstable from git. Do not use in production
# "-beta1" : beta1 release.
# "-beta2" : beta2 release.
# "-beta3" : beta3 release.
# "-rc"    : release candidate.
# ""       : final release. Can be used in production.
set(DIGIKAM_SUFFIX_VERSION "")

# ==============================================================================
# Set env. variables accordingly.

# NOTE: This string is used to set libdigikamcore and libdigikamdatabase SO version ID
set(DIGIKAM_VERSION_SHORT
    "${DIGIKAM_MAJOR_VERSION}.${DIGIKAM_MINOR_VERSION}.${DIGIKAM_PATCH_VERSION}"
)

set(DIGIKAM_VERSION_STRING
    "${DIGIKAM_VERSION_SHORT}${DIGIKAM_SUFFIX_VERSION}"
)

# Core Database XML version
# We must set this variable here at top level because it is used in both
# libs/database/core and data/database
# Version history:
# 1 : Original database XML file, published in production.
# 2 : 08-08-2014 : Fix Images.names field size (see bug #327646).
# 3 : 05/11/2015 : Add Face DB schema.
set(DBCORECONFIG_XML_VERSION "3")

# ==============================================================================

project(digikam
        VERSION ${DIGIKAM_VERSION_SHORT}
        LANGUAGES CXX C)

message(STATUS "----------------------------------------------------------------------------------")
message(STATUS "Starting CMake configuration for ${PROJECT_NAME}")
message(STATUS "")
message(STATUS "Target Build Type: ${CMAKE_BUILD_TYPE}")

# Extra check to detect Qt core with minimal version before to continue.

set(QT5_MIN_VERSION       "5.14.0")
set(QT6_MIN_VERSION       "6.4.0")
set(CMAKE_MODULE_PATH 
                      ${CMAKE_SOURCE_DIR}/core/cmake/modules
                      ${CMAKE_SOURCE_DIR}/core/cmake/macros
                      ${CMAKE_SOURCE_DIR}/core/cmake/rules
)

# Must be done before ECM checks.

include(RulesFindQtCore)

if(Qt6_FOUND)
    set(ECM_MIN_VERSION "5.240.0")
else()
    set(ECM_MIN_VERSION "5.55.0")
endif()

if ("${QT_VERSION}" VERSION_GREATER 6.6.99)
    set(CMAKE_CXX_STANDARD      20)
else()
    set(CMAKE_CXX_STANDARD      17)
endif()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS        OFF)

### ECM setup #########################################################################################################

find_package(ECM ${ECM_MIN_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
                      ${ECM_MODULE_PATH}
)

# KDE Framework macros
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
remove_definitions(-DQT_NO_FOREACH)

# ECM macros
include(ECMSetupVersion)
include(ECMOptionalAddSubdirectory)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(ECMGeneratePriFile)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMPoQmTools)
include(ECMAddTests)
include(ECMMarkAsTest)

# Cmake macros
include(CMakePackageConfigHelpers)
include(GenerateExportHeader)
include(CheckFunctionExists)
include(FeatureSummary)

# Local macros
include(MacroUtils)
include(MacroCompiler)
include(MacroOpenCV)
include(MacroJPEG)
include(MacroBoolTo01)

#######################################################################################################################

APPLY_COMMON_POLICIES()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_AUTOMOC ON)
#set(CMAKE_AUTOUIC ON)
#set(CMAKE_AUTORCC ON)

if(MSVC)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /permissive-")
endif()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY AUTOGEN_TARGETS_FOLDER "Generated")

### COMPILATION OPTIONS MANAGEMENT ####################################################################################

option(DIGIKAMSC_COMPILE_PO              "Build translations files (default=ON)"                                                  ON)
option(DIGIKAMSC_COMPILE_DIGIKAM         "Build digiKam core (default=ON)"                                                        ON)

#######################################################################################################################

if(DIGIKAMSC_COMPILE_PO AND NOT MSVC)
    set_property(GLOBAL PROPERTY ALLOW_DUPLICATE_CUSTOM_TARGETS 1)
endif()

if(BUILD_TESTING)
    include(CTest)
endif()

######################################################################################################################

message(STATUS "----------------------------------------------------------------------------------")
message(STATUS "Top level compilation configuration for ${PROJECT_NAME}")
message(STATUS "")

if(DIGIKAMSC_COMPILE_DIGIKAM)
    if(NOT EXISTS ${CMAKE_SOURCE_DIR}/core)
        message(STATUS "${PROJECT_NAME} will be compiled....................... NO (source code not available)")
        set (DIGIKAMSC_COMPILE_DIGIKAM OFF)
    else()
        message(STATUS "${PROJECT_NAME} will be compiled....................... YES")
    endif()
else()
    message(STATUS     "${PROJECT_NAME} will be compiled....................... NO")
endif()

if(DIGIKAMSC_COMPILE_PO)
    message(STATUS "Translations will be compiled.................. YES")
else()
    message(STATUS "Translations will be compiled.................. NO")
endif()

if(BUILD_TESTING)
    message(STATUS "Tests code will be compiled.................... YES")
else()
    message(STATUS "Tests code will be compiled.................... NO")
endif()

######################################################################################################################

if(DIGIKAMSC_COMPILE_DIGIKAM)
    add_subdirectory(core)
endif()

if(DIGIKAMSC_COMPILE_PO)
    find_package(Gettext REQUIRED)
    find_package(KF${QT_VERSION_MAJOR}I18n NO_MODULE)
    ki18n_install(po)
endif()

if(BUILD_TESTING)

    # Some unit tests require data from the external "Digikam Test Data" git repository.
    # https://invent.kde.org/graphics/digikam-test-data
    #
    # Developers may choose to obtain the data using the "download-repos" script prior to running cmake.
    # For CI runners to run tests, the following custom target serves to perform the download automatically.
    # If the directory "test-data" has already been created, the target becomes a "no-op".
    #
    add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/test-data 
                       COMMENT "Checkout unit-test data repository. Please wait..."
                       COMMAND git
                       ARGS clone https://invent.kde.org/graphics/digikam-test-data.git ${CMAKE_SOURCE_DIR}/test-data)
    add_custom_target(test-data ALL DEPENDS ${CMAKE_SOURCE_DIR}/test-data)

endif()

######################################################################################################################
# API documentation generation

include(RulesDoxygen)

=== core/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2025 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# SPDX-FileCopyrightText: 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
# SPDX-FileCopyrightText: 2015      by Mohamed_Anwer, <m_dot_anwer at gmx dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

# NOTE: Look rules extension scripts located at core/cmake/rules/

APPLY_COMMON_POLICIES()

# ==============================================================================

message(STATUS "----------------------------------------------------------------------------------")
message(STATUS "Check dependencies for ${PROJECT_NAME} version ${DIGIKAM_VERSION_STRING}")
message(STATUS "")

set(KF${QT_VERSION_MAJOR}_MIN_VERSION       "5.95.0")
set(EXIV2_MIN_VERSION                       "0.27.1")
set(OPENCV_MIN_VERSION                      "4.8.0")
set(LENSFUN_MIN_VERSION                     "0.2.6.0")      # For Lens auto-correction plugin
set(KSANE_MIN_VERSION                       "21.12.0")      # For digital scanner support.
set(CALENDAR_MIN_VERSION                    "5.89.0")       # Calendar Core dependency for plugin.
set(AKONADI_MIN_VERSION                     "5.19.0")       # Akonadi Contact dependency.

cmake_minimum_required(VERSION ${CMAKE_MIN_VERSION})

# ==============================================================================

include(RulesOptionDefinitions)

############## Find Packages ###################

# Now detect the whole Qt6 or Qt5 framework.

include(RulesQtFramework)

# KDE frameworks dependencies

include(RulesKDEFramework)

# ==============================================================================
# Dependencies Rules

# mandatory

include(RulesLibJpeg)

find_package(TIFF)
find_package(PNG)
find_package(Boost)
find_package(LCMS2)
find_package(EXPAT)         # For DNGWriter: XMP SDK need Expat library to compile.
find_package(Threads)       # For DNGWriter and LibRaw which needs native threads support.
find_package(Libheif)       # For HEIF support.
find_package(Libjxl)        # For JPEG-XL support with DNGWriter.

if(HEIF_FOUND)

    find_package(X265)      # For HEIF encoding support.

    if(NOT X265_FOUND)

        set(X265_LIBRARIES "")

    endif()

endif()

# -- Exiv2 checks and adjustements ---------------------------------------------

include(RulesLibExiv2)

# -- OpenCV checks and adjustements --------------------------------------------

include(RulesLibOpenCV)

# -- optionals -----------------------------------------------------------------

find_package(FLEX)                                 # For Panorama tool.
find_package(BISON)                                # For Panorama tool.

find_package(LibXslt)                              # For HTMLGallery tool.
find_package(LibXml2)                              # For HTMLGallery tool.

if(ENABLE_GEOLOCATION)

    set(MARBLE_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/utilities/geolocation/engine
                           ${CMAKE_CURRENT_SOURCE_DIR}/utilities/geolocation/engine/geodata/data
    )

else()

    set(MARBLE_INCLUDE_DIR "")

endif()

find_package(PkgConfig)
find_package(Jasper)                               # For JPEG 2000 support.
find_package(Eigen3)                               # For Refocus tool.

# -- ImageMagick checks and adjustements --------------------------------------

include(RulesLibMagick)

# -- X11 checks and adjustements ----------------------------------------------

include(RulesX11)

# -- OpenGL checks and adjustments --------------------------------------------

include(RulesLibOpenGL)

# -- Media player dependencies checks and adjustments---------------------------

include(RulesFFmpeg)
include(RulesMediaPlayer)

# -- Print Install Paths from ECM ---------------------------------------------

include(RulesInstallPaths)

# -- Windows compilation and linking adjustements -----------------------------

include(RulesWindows)

# -- MacOS compilation and linking adjustements -----------------------------

include(RulesMacOS)

# -- To link under Solaris (see bug #274484) ----------------------------------

if(NOT WIN32)

    find_library(MATH_LIBRARY m)

endif()

if(CMAKE_SYSTEM_NAME STREQUAL FreeBSD)

    find_library(KVM_LIBRARY kvm)

endif()

# ==============================================================================
# More Optional Dependencies and Rules

find_package(GLIB2)

if(BUILD_WITH_CCACHE)

    message(STATUS "Looking for ccache...")
    find_program(CCACHE_FOUND ccache)
    message(STATUS "ccache program found: ${CCACHE_FOUND}...")

endif()

# -- Check libgphoto2 library for camera devices support -----------------------

include(RulesLibgphoto2)

# -- Check LensFun library for Lens auto-correction tool -----------------------

include(RulesLiblensfun)

# -- Check dependencies for Panorama tool --------------------------------------

if(FLEX_FOUND AND BISON_FOUND AND KF${QT_VERSION_MAJOR}ThreadWeaver_FOUND)

    set(HAVE_PANORAMA 1)

else()

    set(HAVE_PANORAMA 0)

endif()

# -- Check dependencies for HTMLGallery tool -----------------------------------

if(LibXml2_FOUND AND LibXslt_FOUND)

    set(HAVE_HTMLGALLERY 1)

else()

    set(HAVE_HTMLGALLERY 0)

endif()

# -- Check dependencies for libraw ---------------------------------------------

include(RulesLibraw)

# -- Debug Symbols rules under MacOS -------------------------------------------

MACOS_DEBUG_POLICIES()


# -- Compilation options definitions -------------------------------------------

message(STATUS "--------------------------------------------------")
message(STATUS "")

if(Qt6_FOUND)

    MACRO_BOOL_TO_01(KSaneWidgets6_FOUND                        HAVE_KSANE)

else()

    MACRO_BOOL_TO_01(KF${QT_VERSION_MAJOR}Sane_FOUND            HAVE_KSANE)

endif()

MACRO_BOOL_TO_01(KF${QT_VERSION_MAJOR}FileMetaData_FOUND        HAVE_KFILEMETADATA)
MACRO_BOOL_TO_01(KF${QT_VERSION_MAJOR}CalendarCore_FOUND        HAVE_KCALENDAR)
MACRO_BOOL_TO_01(KF${QT_VERSION_MAJOR}Notifications_FOUND       HAVE_KNOTIFICATIONS)
MACRO_BOOL_TO_01(KF${QT_VERSION_MAJOR}NotifyConfig_FOUND        HAVE_KNOTIFYCONFIG)
MACRO_BOOL_TO_01(KF${QT_VERSION_MAJOR}KIO_FOUND                 HAVE_KIO)
MACRO_BOOL_TO_01(KF${QT_VERSION_MAJOR}IconThemes_FOUND          HAVE_KICONTHEMES)
MACRO_BOOL_TO_01(KF${QT_VERSION_MAJOR}Sonnet_FOUND              HAVE_SONNET)
MACRO_BOOL_TO_01(LensFun_FOUND                                  HAVE_LENSFUN)
MACRO_BOOL_TO_01(Gphoto2_FOUND                                  HAVE_GPHOTO2)
MACRO_BOOL_TO_01(Jasper_FOUND                                   HAVE_JASPER)
MACRO_BOOL_TO_01(Eigen3_FOUND                                   HAVE_EIGEN3)
MACRO_BOOL_TO_01(ENABLE_GEOLOCATION                             HAVE_GEOLOCATION)
MACRO_BOOL_TO_01(ENABLE_AKONADICONTACTSUPPORT                   HAVE_AKONADICONTACT)
MACRO_BOOL_TO_01(ENABLE_MYSQLSUPPORT                            HAVE_MYSQLSUPPORT)
MACRO_BOOL_TO_01(ENABLE_INTERNALMYSQL                           HAVE_INTERNALMYSQL)
MACRO_BOOL_TO_01(ENABLE_MEDIAPLAYER                             HAVE_MEDIAPLAYER)
MACRO_BOOL_TO_01(ENABLE_QTMULTIMEDIA                            HAVE_QTMULTIMEDIA)
MACRO_BOOL_TO_01(ENABLE_DBUS                                    HAVE_DBUS)
MACRO_BOOL_TO_01(ENABLE_APPSTYLES                               HAVE_APPSTYLE_SUPPORT)
MACRO_BOOL_TO_01(ImageMagick_FOUND                              HAVE_IMAGE_MAGICK)
MACRO_BOOL_TO_01(HEIF_FOUND                                     HAVE_HEIF)
MACRO_BOOL_TO_01(X265_FOUND                                     HAVE_X265)
MACRO_BOOL_TO_01(JXL_FOUND                                      HAVE_JXL)
MACRO_BOOL_TO_01(Qt5XmlPatterns_FOUND                           HAVE_QTXMLPATTERNS)
MACRO_BOOL_TO_01(CCACHE_FOUND                                   HAVE_CCACHE)

# Set config files accordingly with optional dependencies

configure_file(app/utils/digikam_config.h.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/app/utils/digikam_config.h)

# ==============================================================================
# Log messages

message(STATUS "")
message(STATUS "----------------------------------------------------------------------------------")
message(STATUS " digiKam ${DIGIKAM_VERSION_STRING} dependencies results   <https://www.digikam.org>")
message(STATUS "")

PRINT_COMPONENT_COMPILE_STATUS("MySQL Database Support"                     ENABLE_MYSQLSUPPORT)
PRINT_COMPONENT_COMPILE_STATUS("MySQL Internal Support"                     ENABLE_INTERNALMYSQL)
PRINT_COMPONENT_COMPILE_STATUS("Showfoto Support"                           ENABLE_SHOWFOTO)
PRINT_COMPONENT_COMPILE_STATUS("DBUS Support"                               ENABLE_DBUS)
PRINT_COMPONENT_COMPILE_STATUS("App. Style Support"                         ENABLE_APPSTYLES)
PRINT_COMPONENT_COMPILE_STATUS("Geolocation Support"                        ENABLE_GEOLOCATION)
PRINT_COMPONENT_COMPILE_STATUS("Media Player Support"                       ENABLE_MEDIAPLAYER)
PRINT_COMPONENT_COMPILE_STATUS("QtMultimedia Support"                       ENABLE_QTMULTIMEDIA)

# ==============================================================================

PRINT_LIBRARY_STATUS("libboostgraph" "https://github.com/boostorg/boost"                 "(version >= 1.43.0)"                Boost_FOUND)

if(LibExiv2_FOUND)

    PRINT_LIBRARY_STATUS("LibExiv2"  "https://github.com/Exiv2/exiv2"                    "(version >= ${EXIV2_MIN_VERSION}"   LibExiv2_FOUND)

else()

    PRINT_LIBRARY_STATUS("libexiv2"  "https://github.com/Exiv2/exiv2"                    "(version >= ${EXIV2_MIN_VERSION}"   exiv2_FOUND)

endif()

PRINT_LIBRARY_STATUS("libexpat"      "https://libexpat.github.io"                        "(version >= 2.0.0)"                 EXPAT_FOUND)
PRINT_LIBRARY_STATUS("libjpeg"       "https://github.com/libjpeg-turbo/libjpeg-turbo"    "(version >= 6b)"                    JPEG_FOUND)
PRINT_LIBRARY_STATUS("libkde"        "https://invent.kde.org/frameworks/"                "(version >= ${KF${QT_VERSION_MAJOR}_MIN_VERSION})"    KF${QT_VERSION_MAJOR}_FOUND)
PRINT_LIBRARY_STATUS("liblcms"       "https://github.com/mm2/Little-CMS"                 "(version >= 2.0.0)"                 LCMS2_FOUND)
PRINT_LIBRARY_STATUS("libopencv"     "https://github.com/opencv/opencv"                  "(version >= ${OPENCV_MIN_VERSION})" OpenCV_FOUND)
PRINT_LIBRARY_STATUS("libpng"        "https://libpng.sourceforge.io/"                    "(version >= 1.2.7)"                 PNG_FOUND)
PRINT_LIBRARY_STATUS("libpthread"    "https://www.gnu.org/software/hurd/libpthread.html" "(version >= 2.0.0)"                 CMAKE_USE_PTHREADS_INIT OR CMAKE_USE_WIN32_THREADS_INIT)
PRINT_LIBRARY_STATUS("libqt"         "https://code.qt.io/cgit/qt/qtbase.git/"            "(version >= ${QT_MIN_VERSION})"     Qt${QT_VERSION_MAJOR}_FOUND)
PRINT_LIBRARY_STATUS("libtiff"       "https://gitlab.com/libtiff/libtiff/"               "(version >= 3.8.2)"                 TIFF_FOUND)

# ==============================================================================

PRINT_OPTIONAL_LIBRARY_STATUS("bison"             "https://www.gnu.org/software/bison/bison.html"                   "(version >= 2.5.0)"                    "digiKam will be compiled without Panorama support."                          BISON_FOUND)
PRINT_OPTIONAL_LIBRARY_STATUS("ccache"            "https://ccache.dev"                                              "(version >= 3.0.0)"                    "digiKam will be compiled without CCACHE build support."                      HAVE_CCACHE)
PRINT_OPTIONAL_LIBRARY_STATUS("flex"              "https://github.com/westes/flex"                                  "(version >= 2.5.0)"                    "digiKam will be compiled without Panorama support."                          FLEX_FOUND)

=== core/app/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2025 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# SPDX-FileCopyrightText: 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

APPLY_COMMON_POLICIES()

# -----------------------------------------------------------------------------------
# Headers to configure

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/utils/digikam_version.h.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/utils/digikam_version.h)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/utils/digikam_dbconfig.h.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/utils/digikam_dbconfig.h)

# -----------------------------------------------------------------------------------
# Define common includes rules for digiKam targets

HEADER_DIRECTORIES(${CMAKE_SOURCE_DIR}/core/utilities DK_LOCAL_INCLUDES_UTILS)

set(DIGIKAM_TARGET_INCLUDES $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::PrintSupport,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Gui,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Xml,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Widgets,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Core,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Sql,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Network,INTERFACE_INCLUDE_DIRECTORIES>

                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::I18n,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::Solid,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::WindowSystem,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::XmlGui,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::Service,INTERFACE_INCLUDE_DIRECTORIES>
                            $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::CoreAddons,INTERFACE_INCLUDE_DIRECTORIES>

                            ${CMAKE_SOURCE_DIR}/core/app/main
                            ${CMAKE_SOURCE_DIR}/core/app/date
                            ${CMAKE_SOURCE_DIR}/core/app/filters
                            ${CMAKE_SOURCE_DIR}/core/app/dragdrop
                            ${CMAKE_SOURCE_DIR}/core/app/views/stack
                            ${CMAKE_SOURCE_DIR}/core/app/views/utils
                            ${CMAKE_SOURCE_DIR}/core/app/views/sidebar
                            ${CMAKE_SOURCE_DIR}/core/app/views/tableview
                            ${CMAKE_SOURCE_DIR}/core/app/items/utils
                            ${CMAKE_SOURCE_DIR}/core/app/items/thumbbar
                            ${CMAKE_SOURCE_DIR}/core/app/items/delegate
                            ${CMAKE_SOURCE_DIR}/core/app/items/views
                            ${CMAKE_SOURCE_DIR}/core/app/items/overlays
                            ${CMAKE_SOURCE_DIR}/core/app/views/preview

                            ${DK_LOCAL_INCLUDES}
                            ${DK_LOCAL_INCLUDES_UTILS}
)

if(KF${QT_VERSION_MAJOR}IconThemes_FOUND)
    set(DIGIKAM_TARGET_INCLUDES
        ${DIGIKAM_TARGET_INCLUDES}
        $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::IconThemes,INTERFACE_INCLUDE_DIRECTORIES>)
endif()

set(DIGIKAM_TARGET_INCLUDES
    ${DIGIKAM_TARGET_INCLUDES}
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::WebEngineWidgets,INTERFACE_INCLUDE_DIRECTORIES>
)

if(KF${QT_VERSION_MAJOR}KIO_FOUND)
    set(DIGIKAM_TARGET_INCLUDES
        ${DIGIKAM_TARGET_INCLUDES}
        $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::KIOWidgets,INTERFACE_INCLUDE_DIRECTORIES>)
endif()

if(Gphoto2_FOUND)
    set(DIGIKAM_TARGET_INCLUDES
        ${DIGIKAM_TARGET_INCLUDES}
        ${GPHOTO2_INCLUDE_DIRS})
endif()

# -----------------------------------------------------------------------------------
# Targets to build

include(DigikamCoreTarget.cmake)
include(DigikamDatabaseTarget.cmake)
include(DigikamGuiTarget.cmake)
include(DigikamTarget.cmake)

# -----------------------------------------------------------------------------------
# Others Files to install

install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/main/org.kde.digikam.desktop     DESTINATION ${KDE_INSTALL_FULL_APPDIR})
install(FILES    ${CMAKE_CURRENT_SOURCE_DIR}/main/org.kde.digikam.appdata.xml DESTINATION ${KDE_INSTALL_FULL_METAINFODIR})
install(FILES    ${CMAKE_CURRENT_SOURCE_DIR}/main/digikamui5.rc               DESTINATION ${KDE_INSTALL_FULL_KXMLGUIDIR}/digikam)
install(FILES    ${CMAKE_CURRENT_SOURCE_DIR}/main/digikam.notifyrc            DESTINATION ${KDE_INSTALL_FULL_KNOTIFYRCDIR})

include(DigikamExportAPI.cmake)

=== core/libs/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2025 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

# NOTE: include this common rules on top level for DNGWriter and RawEngine.

include(RulesDNGSdk)

HEADER_DIRECTORIES(${CMAKE_SOURCE_DIR}/core/utilities DK_LOCAL_INCLUDES_UTILS)

include_directories(${DK_LOCAL_INCLUDES}
                    ${DK_LOCAL_INCLUDES_UTILS}

                    ${CMAKE_SOURCE_DIR}/core/app/main
                    ${CMAKE_SOURCE_DIR}/core/app/date
                    ${CMAKE_SOURCE_DIR}/core/app/dragdrop
                    ${CMAKE_SOURCE_DIR}/core/app/views/stack
                    ${CMAKE_SOURCE_DIR}/core/app/views/utils
                    ${CMAKE_SOURCE_DIR}/core/app/items/utils
                    ${CMAKE_SOURCE_DIR}/core/app/items/delegate
                    ${CMAKE_SOURCE_DIR}/core/app/views/sidebar
)

add_subdirectory(dimg)
add_subdirectory(dragdrop)
add_subdirectory(metadataengine)
add_subdirectory(database)
add_subdirectory(dtrash)
add_subdirectory(facesengine)
add_subdirectory(iojobs)
add_subdirectory(imgqsort)
add_subdirectory(jpegutils)
add_subdirectory(pgfutils)
add_subdirectory(threadimageio)
add_subdirectory(widgets)
add_subdirectory(properties)
add_subdirectory(progressmanager)
add_subdirectory(threads)
add_subdirectory(versionmanager)
add_subdirectory(networkmanager)
add_subdirectory(notificationmanager)
add_subdirectory(models)
add_subdirectory(onlineversion)
add_subdirectory(template)
add_subdirectory(dialogs)
add_subdirectory(dplugins)
add_subdirectory(fileactionmanager)
add_subdirectory(filters)
add_subdirectory(settings)
add_subdirectory(rawengine)
add_subdirectory(album)
add_subdirectory(tags)
add_subdirectory(transitionmngr)
add_subdirectory(timeadjust)
add_subdirectory(video)
add_subdirectory(dnnmodelmanager)
add_subdirectory(mlfoundation)
add_subdirectory(qtopencvimg)
add_subdirectory(autorotator)
add_subdirectory(aitoolspipeline)

if(JXL_FOUND)

    add_subdirectory(dngwriter)

endif()

=== core/data/about/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2025 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

install(FILES main.html
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/about
)

install(DIRECTORY css/
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/about/css
)

install(DIRECTORY images/
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/about/images
)

install(DIRECTORY js/
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/about/js
)

=== core/data/colorschemes/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2025 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

file(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.colors")

install(FILES ${files}
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/colorschemes
)

=== core/data/database/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2025 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

# NOTE: the DBCORECONFIG_XML_VERSION ID is configured in the toplevel CMakeLists.txt,
configure_file(dbconfig.xml.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/dbconfig.xml)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dbconfig.xml
              ${CMAKE_CURRENT_SOURCE_DIR}/mysql-global.conf
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/database
)

=== core/data/filters/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2015, Andrej Krutak, <dev at andree dot sk>
#
# SPDX-License-Identifier: BSD-3-Clause
#

add_subdirectory(lut3d)

=== core/data/profiles/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2024, Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

file(GLOB icmfiles *.icm *.icc)

install(FILES  ${icmfiles}
        DESTINATION ${KDE_INSTALL_FULL_DATADIR}/digikam/profiles)

=== core/libs/database/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2025 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# SPDX-FileCopyrightText: 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
# SPDX-FileCopyrightText: 2015      by Mohamed_Anwer, <m_dot_anwer at gmx dot com>
# SPDX-FileCopyrightText: 2018      by Mario Frank,   <mario dot frank at uni minus potsdam dot de>
#
# SPDX-License-Identifier: BSD-3-Clause
#

APPLY_COMMON_POLICIES()

include_directories(
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Xml,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Sql,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Widgets,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Network,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Core,INTERFACE_INCLUDE_DIRECTORIES>

    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::Solid,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::I18n,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::ConfigCore,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::CoreAddons,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::WidgetsAddons,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::XmlGui,INTERFACE_INCLUDE_DIRECTORIES>

    ${CMAKE_SOURCE_DIR}/core/libs/dplugins/webservices/o2/src

    ${Boost_INCLUDE_DIRS}
)

if(ENABLE_DBUS)
    include_directories($<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::DBus,INTERFACE_INCLUDE_DIRECTORIES>)
endif()

# Boost uses operator names (and, not, ...)
string(REPLACE "-fno-operator-names" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

### For digikamcore target - Symbols exported with DIGIKAM_EXPORT macro ##########################

set(libdatabasecore_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/server/databaseserverstarter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/server/databaseservererror.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/server/databaseserver.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/engine/dbengineconfigloader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/engine/dbengineconfig.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/engine/dbengineactiontype.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/engine/dbengineerrorhandler.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/engine/dbengineguierrorhandler.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/engine/dbengineparameters.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/engine/dbenginebackend.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/engine/dbenginesqlquery.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/engine/dbengineaccess.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/tags/tagregion.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/thumbsdb/thumbsdb.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbsdb/thumbsdbschemaupdater.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbsdb/thumbsdbbackend.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbsdb/thumbsdbaccess.cpp
)

# Used by digikamcore
add_library(core_digikamdatabase_obj OBJECT ${libdatabasecore_SRCS})

target_compile_definitions(core_digikamdatabase_obj
                           PRIVATE
                           digikamcore_EXPORTS
)

### For digikamdatabase target - Symbols exported with DIGIKAM_DATABASE_EXPORT macro ##############

set(libdatabase_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/collection/collectionscanner.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collection/collectionscanner_p.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collection/collectionscanner_scan.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collection/collectionscanner_utils.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collection/collectionmanager.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collection/collectionmanager_p.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collection/collectionmanager_location.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collection/collectionmanager_album.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collection/collectionlocation.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collection/collectionscannerhints.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredb.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbsearchxml.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbchecker.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbcopymanager.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbconstants.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbtransaction.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbschemaupdater.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbchangesets.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbthumbinfoprovider.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredboperationgroup.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbbackend.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbwatch.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredburl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbaccess.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbnamefilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbdownloadhistory.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/tags/tagproperties.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tags/tagscache.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tags/facetags.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tags/facetagseditor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tags/facetagsiface.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/dbjobs/dbjobsthread.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dbjobs/dbjob.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dbjobs/dbjobinfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dbjobs/dbjobsmanager.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dbjobs/duplicatesprogressobserver.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfo_p.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfo_containers.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfo_geolocation.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfo_groups.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfo_history.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfo_labels.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfo_properties.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfo_similarity.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfo_tags.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfo_thumbnail.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfodata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfolist.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/iteminfocache.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/itemcomments.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/itemcopyright.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/itemposition.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/itemtagpair.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/containers/itemextendedproperties.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/item/lister/itemlister.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/lister/itemlister_palbum.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/lister/itemlister_talbum.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/lister/itemlister_salbum.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/lister/itemlisterrecord.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/lister/itemlisterreceiver.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/lister/itemattributeswatch.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/item/query/itemquerybuilder.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/query/itemquerybuilder_p.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/query/itemqueryposthooks.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/query/fieldquerybuilder.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/item/scanner/itemscanner.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/scanner/itemscanner_p.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/scanner/itemscanner_database.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/scanner/itemscanner_file.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/scanner/itemscanner_photo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/scanner/itemscanner_video.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/scanner/itemscanner_history.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/item/scanner/itemscanner_baloo.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/history/itemhistorygraph.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/history/itemhistorygraphmodel.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/similaritydb/similaritydb.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/similaritydb/similaritydbschemaupdater.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/similaritydb/similaritydbbackend.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/similaritydb/similaritydbaccess.cpp
)

if(ENABLE_DBUS)
    set(libdatabase_SRCS
        ${libdatabase_SRCS}
        ${CMAKE_CURRENT_SOURCE_DIR}/coredb/coredbwatchadaptor.cpp
       )
endif()

# enable exceptions
kde_source_files_enable_exceptions(${CMAKE_CURRENT_SOURCE_DIR}/history/itemhistorygraph.cpp
                                   ${CMAKE_CURRENT_SOURCE_DIR}/history/itemhistorygraphmodel.cpp
)

set(libdatabasemodels_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/models/itemfiltermodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/models/itemfiltermodel_p.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/models/itemfiltermodelthreads.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/models/itemfiltersettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/models/itemversionsmodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/models/itemthumbnailmodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/models/itemsortcollator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/models/itemsortsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/models/itemlistmodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/models/itemmodel.cpp
)

set(libhaar_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/haar/haar.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/haar/haariface.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/haar/haariface_p.cpp
)

# Used by digikamdatabase
add_library(digikamdatabase_obj OBJECT ${libdatabase_SRCS}
                                       ${libdatabasemodels_SRCS}
                                       ${libhaar_SRCS}
)

target_compile_definitions(digikamdatabase_obj
                           PRIVATE
                           digikamdatabase_EXPORTS
)

# Specific settings with C++20 required by Qt 6.7 and later for history classes based on Boost.
# TODO: check if new MSVC do not report a compilation error with Boost code.

if(MSVC OR APPLE)

    set_target_properties(digikamdatabase_obj
                          PROPERTIES
                          CXX_STANDARD 17
                          CXX_STANDARD_REQUIRED YES
                          CXX_EXTENSIONS NO
    )

endif()

### For digikamgui target - Symbols exported with DIGIKAM_EXPORT macro ############################

set(libdatabasemain_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/widgets/dbstatdlg.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/widgets/dbsettingswidget.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/widgets/dbmigrationdlg.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/widgets/mysqlupgradebinary.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/widgets/mysqlserverbinary.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/widgets/mysqladminbinary.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/widgets/mysqlinitbinary.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/widgets/searchtextbardb.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/utils/ifaces/dbinfoiface.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/ifaces/syncjob.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/ifaces/dio.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/ifaces/diofinders.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/utils/scan/scancontroller.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/scan/scancontroller_p.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/scan/scancontroller_start.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/scan/scancontroller_progress.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/utils/scan/scancontroller_stop.cpp
)

if(ENABLE_GEOLOCATION)
    set(libdatabasemain_SRCS
        ${libdatabasemain_SRCS}
        ${CMAKE_CURRENT_SOURCE_DIR}/utils/ifaces/itemgps.cpp
       )
endif()

# Used by digikamgui
add_library(gui_digikamdatabasemain_obj OBJECT ${libdatabasemain_SRCS})

target_compile_definitions(gui_digikamdatabasemain_obj
                           PRIVATE
                           digikamgui_EXPORTS
)

=== core/libs/dplugins/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2025 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

APPLY_COMMON_POLICIES()

include_directories($<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Widgets,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Core,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Network,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Gui,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Xml,INTERFACE_INCLUDE_DIRECTORIES>

                    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::XmlGui,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::I18n,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::ConfigCore,INTERFACE_INCLUDE_DIRECTORIES>

                    ${CMAKE_SOURCE_DIR}/core/libs/dplugins/webservices/o2/src
)

    include_directories($<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::WebEngineWidgets,INTERFACE_INCLUDE_DIRECTORIES>)

if(KF${QT_VERSION_MAJOR}KIO_FOUND)
    include_directories($<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::KIOCore,INTERFACE_INCLUDE_DIRECTORIES>
                        $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::KIOFileWidgets,INTERFACE_INCLUDE_DIRECTORIES>
    )
endif()

set(libdpluginsinterface_SRCS

    ${CMAKE_CURRENT_SOURCE_DIR}/core/dplugin.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/core/dplugingeneric.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/core/dplugineditor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/core/dpluginrawimport.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/core/dplugindimg.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/core/dpluginauthor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/core/dpluginaction.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/setup/dpluginloader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/dpluginloader_p.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/dpluginconfview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/dpluginconfviewgeneric.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/dpluginconfvieweditor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/dpluginconfviewdimg.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/dpluginsetup.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/dpluginaboutdlg.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/iface/dinfointerface.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/iface/dmetainfoiface.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/dplugindialog.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/dwizardpage.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/dwizarddlg.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/dsavesettingswidget.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/dwizardpage.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/dpreviewmanager.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/dpreviewimage.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/ditemslist.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/ditemslist_item.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/ditemslist_view.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/webservices/wscomboboxdelegate.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/webservices/wscomboboxintermediate.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/webservices/wstooldialog.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/webservices/wstoolutils.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/webservices/wssettingswidget.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/webservices/wsselectuserdlg.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/webservices/wslogindialog.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/webservices/wsnewalbumdialog.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/webservices/wssettings.cpp
)

#set(libdpluginsinterface_SRCS
#    ${libdpluginsinterface_SRCS}
#    ${CMAKE_CURRENT_SOURCE_DIR}/webservices/webwidget_qwebengine.cpp
#)

# Used by digikamcore
add_library(core_dpluginsinterface_obj OBJECT ${libdpluginsinterface_SRCS})

target_compile_definitions(core_dpluginsinterface_obj
                           PRIVATE
                           digikamcore_EXPORTS
)

# Parse O2 library code and rules at end, and compilation rules remove important Qt definitions.

if(WIN32)
    # NOTE: this O2 export symbols rule must be on top level.
    add_definitions(-DO2_DLL_EXPORT)
endif()

add_subdirectory(webservices)

=== core/libs/imgqsort/CMakeLists.txt ===
#
# SPDX-FileCopyrightText: 2010-2025 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# SPDX-FileCopyrightText: 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
#
# SPDX-License-Identifier: BSD-3-Clause
#

APPLY_COMMON_POLICIES()

kde_enable_exceptions()

set(libimgqsort_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/imagequalitysettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/imagequalitywidget.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/imagequalityparser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/imagequalitycalculator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/imagequalitythread.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/detectors/abstract_detector.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/detectors/aesthetic_detector.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/detectors/blur_detector.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/detectors/compression_detector.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/detectors/exposure_detector.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/detectors/noise_detector.cpp
)

include_directories(
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Concurrent,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Core,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Gui,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Widgets,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt${QT_VERSION_MAJOR}::Xml,INTERFACE_INCLUDE_DIRECTORIES>

    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::ConfigCore,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:KF${QT_VERSION_MAJOR}::I18n,INTERFACE_INCLUDE_DIRECTORIES>
)

# Used by digikamgui
add_library(gui_imgqsort_obj OBJECT ${libimgqsort_SRCS})

target_compile_definitions(gui_imgqsort_obj
                           PRIVATE
                           digikamgui_EXPORTS
)

=== debian/changelog ===
digikam (4:8.7.0-1ubuntu2) questing; urgency=medium

  * No-change rebuild for Qt 6.9.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Wed, 17 Sep 2025 06:28:54 +0100

digikam (4:8.7.0-1ubuntu1) questing; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Add apparmor profile to fix userns:
      + Add debian/digikam-apparmor.
      + debian/control: Depend on apparmor, build depend on dh-apparmor and
        debhelper-compat (=13).
      + debian/rules:copy profile to tmp dir and invoke dh_apparmor.
      + debian/digikam.install: Install profile.

 -- Rik Mills <rikmills@kde.org>  Sun, 17 Aug 2025 10:11:04 +0100

digikam (4:8.7.0-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [8d71b77] New upstream version 8.7.0

 -- Steve M. Robbins <smr@debian.org>  Sat, 16 Aug 2025 12:09:57 -0500

digikam (4:8.7.0-0ubuntu1) questing; urgency=medium

  * New upstream release (8.7.0)

 -- Rik Mills <rikmills@kde.org>  Tue, 01 Jul 2025 09:19:10 +0100

digikam (4:8.6.0-1ubuntu2) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 23 May 2025 06:06:10 +0200

digikam (4:8.6.0-1ubuntu1) questing; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Add apparmor profile to fix userns:
      + Add debian/digikam-apparmor.
      + debian/control: Depend on apparmor, build depend on dh-apparmor and
        debhelper-compat (=13).
      + debian/rules:copy profile to tmp dir and invoke dh_apparmor.
      + debian/digikam.install: Install profile.

 -- Rik Mills <rikmills@kde.org>  Mon, 12 May 2025 07:52:00 +0100

=== debian/control ===
Source: digikam
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
Section: graphics
Priority: optional
Build-Depends: debhelper-compat (= 13),
# Build Helpers
               appstream,
               bison,
               cmake (>= 3.22.0),
               dh-apparmor,
               extra-cmake-modules (>= 5.91.0),
               flex,
               gphoto2,
               help2man,
# KDE Components
               libkf6calendarcore-dev,
               libkf6contacts-dev,
               libkf6filemetadata-dev,
               libkf6iconthemes-dev,
               libkf6kio-dev,
               libkf6notifyconfig-dev,
               libkf6service-dev,
               libkf6solid-dev,
               libkf6sonnet-dev,
               libkf6threadweaver-dev,
               libkf6windowsystem-dev,
               libkf6xmlgui-dev,
# Qt Libraries
               qt6-multimedia-dev,
               qt6-networkauth-dev,
               qt6-scxml-dev,
               qt6-svg-dev,
               qt6-webengine-dev,
# FFMPEG libraries
               libavcodec-dev,
               libavdevice-dev,
               libavfilter-dev,
               libavformat-dev,
               libavutil-dev,
               libpostproc-dev,
               libswresample-dev,
               libswscale-dev,
               libboost-graph-dev,
               libeigen3-dev,
               libexiv2-dev,
               libexpat1-dev | libexpat-dev,
               libheif-dev,
               libgphoto2-dev,
               libjpeg-dev,
               libjxl-dev,
               liblcms2-dev,
               liblensfun-dev,
               liblqr-1-0-dev,
               libmagick++-dev (>= 7),
               imagemagick-7.q16,
               libmarble-dev,
               libopencv-dev (>= 4.10),
               libpng-dev,
               libpulse-dev,
               libtiff-dev,
               libusb-1.0-0-dev [linux-any],
               libx265-dev,
               libxslt1-dev,
               libxml2-dev,
               libxv-dev,
               pkgconf,
               pkg-kde-tools,
               portaudio19-dev
Build-Conflicts: libgraphicsmagick1-dev,
                 imagemagick-6-common (<< 7.0),
                 libboost1.62-dev (<< 1.62.0+dfsg-4)
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/digikam
Vcs-Git: https://salsa.debian.org/debian/digikam.git
Homepage: http://www.digikam.org

Package: digikam-private-libs
Architecture: amd64 arm64 armhf i386
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: private libraries for digiKam plugins
 This package contains private libraries to be used by digikam.
 .
 This has no use for anything else than digikam, since the libraries are
 installed in a private library path.

Package: digikam
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends},
         digikam-private-libs (= ${binary:Version}),
         libqt6sql6-sqlite,
         libqt6sql6-mysql,
         digikam-data (= ${source:Version})
Recommends: www-browser,
            ffmpegthumbs
Suggests: libimage-exiftool-perl,
          breeze-icon-theme,
          systemsettings,
          apparmor,
Description: digital photo management application for KDE
 Digital photo management program designed to import, organize, enhance, search
 and export your digital images to and from your computer.
 .
 It provides a simple interface which makes importing and organizing digital
 photographs a "snap". digiKam enables you to manage large numbers of
 digital photographs in albums and to organize these photographs for easy
 retrieval using tags (keywords), captions, collections, dates, geolocation
 and searches. It has many features for viewing, organizing, processing and
 sharing your images. Thus, digiKam is a formidable digital asset management
 (DAM) software including powerful image editing functions.
 .
 An easy-to-use camera interface is provided, that will connect to your
 digital camera and download photographs directly into digiKam albums.
 More than 1000 digital cameras are supported by the gphoto2 library.
 Of course, any media or card reader supported by your operating system
 will interface with digiKam.
 .
 digiKam incorporates a fast Image Editor with many image editing tools.
 You can use the Image Editor to view your photographs, comment and rate
 them, correct, enhance and alter them. The editing power can be easily
 extended by a set of plugins, the KDE Image Plugins Interface (manual)
 .
 While digiKam remains easy to use, it provides professional level features
 by the dozens. It is fully 16 bit enabled including all available plugins,
 supports RAW format conversion through libraw, DNG export and ICC color
 management work flow.

Package: showfoto
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         digikam-data (= ${source:Version}),
         digikam-private-libs (= ${binary:Version})
Recommends: dolphin
Description: image viewer/editor for KDE
 showFoto is the standalone image editor of the digiKam project.
 .
 It runs without digiKam images database support, but provides all Image Editor
 functions.

Package: digikam-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         opencv-data
Description: digiKam architecture-independant data
 Contains the significant amount of architecture-independent data that is
 shipped with digiKam.
 .
 It has been placed in an architecture all file to reduce space on the
 archives, rather than one copy for each architecture.

=== debian/rules ===
#!/usr/bin/make -f

PRIVATE_LIBDIR := /usr/lib/digikam
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Augment path to find gphoto2-config; workaround for #826166
export PATH := $(PATH):/usr/lib/$(DEB_HOST_MULTIARCH)/libgphoto2-dev/bin


%:
	dh $@ --with kf6

override_dh_auto_configure:
	dh_auto_configure --buildsystem=kf6 -- \
	  -DBUILD_WITH_QT6=on \
	  -DCMAKE_INSTALL_RPATH="$(PRIVATE_LIBDIR)" \
	  -DBUILD_TESTING=OFF \
	  -DDIGIKAMSC_COMPILE_DOC=on \
	  -DDIGIKAMSC_COMPILE_PO=on \
	  -DENABLE_MYSQLSUPPORT=ON \
	  -DENABLE_INTERNALMYSQL=ON \
	  -DENABLE_KFILEMETADATASUPPORT=ON \
	  -DENABLE_AKONADICONTACTSUPPORT=ON \
	  -DENABLE_MEDIAPLAYER=ON \
	  -DENABLE_APPSTYLES=ON

#	help2man -n 'digital photo management application' --no-info obj-*/core/app/digikam > debian/man/digikam.1
#	help2man -n 'image viewer/editor' --no-info obj-*/core/showfoto/showfoto > debian/man/showfoto.1

override_dh_auto_install:
	dh_auto_install
	# remove development stuff: headers, cmake config files, pkg-config files, .so symlinks, static libs
	rm -rf --verbose debian/tmp/usr/include
	rm -rf --verbose debian/tmp/usr/share/kde4/apps/cmake
	rm -rf --verbose debian/tmp/usr/lib/cmake
	rm -rf --verbose debian/tmp/usr/lib/*/cmake
	rm -rf --verbose debian/tmp/usr/lib/pkgconfig
	find debian/tmp/usr/lib -type l -name '*.so' -exec rm --verbose {} \;
	# remove potentially conflicting oxygen icons in global icon theme
	rm -rf --verbose debian/tmp/usr/share/icons/oxygen
	# remove haar cascades, the versions in opencv-data will be used instead
	rm -rf --verbose debian/tmp/usr/share/kde4/apps/libkface/haarcascades
	# remove icons for non-installed test program
	rm -f --verbose debian/tmp/usr/share/icons/hicolor/*/apps/avplayer.*
	mkdir -p debian/tmp/etc/apparmor.d
	cp debian/digikam-apparmor debian/tmp/etc/apparmor.d/usr.bin.digikam
	dh_apparmor --profile-name=usr.bin.digikam -pdigikam

override_dh_installchangelogs:
	dh_installchangelogs -pdigikam ChangeLog
	dh_installchangelogs --remaining-packages

override_dh_install:
	dh_install
	dh_missing --fail-missing

override_dh_shlibdeps:
	dh_shlibdeps -l$(CURDIR)/debian/digikam-private-libs/$(PRIVATE_LIBDIR)

# auto tests require user interaction - override
override_dh_auto_test:
